import{s as yt,n as bt,o as vt}from"../chunks/scheduler.7da89386.js";import{S as xt,i as $t,g as s,s as a,r as p,A as Qt,h as m,f as e,c as o,j as C,u as g,x as U,k as D,y as i,a as d,v as f,d as h,t as z,w as _}from"../chunks/index.0b7befd3.js";import{D as k}from"../chunks/Docstring.b7b38e43.js";import{H as at}from"../chunks/Heading.8a936589.js";function qt(ut){let l,V,E,W,x,S,$,pt='Please refer to the guide <a href="https://huggingface.co/docs/optimum/amd/ryzenai/usage_guides/quantization" rel="nofollow">How to apply quantization</a> to understand how to use the following classes to quantize models targeting Ryzen AI IPU.',X,Q,j,q,B,r,I,ot,P,gt="Handles the RyzenAI quantization process for models shared on huggingface.co/models.",it,y,O,rt,N,ft="Instantiates a <code>RyzenAIOnnxQuantizer</code> from an ONNX model file.",st,b,T,mt,L,ht="Creates the calibration <code>datasets.Dataset</code> to use for the post-training static quantization calibration step.",dt,v,w,ct,M,zt="Quantizes a model given the optimization specifications defined in <code>quantization_config</code>.",G,A,J,u,R,lt,H,_t="QuantizationConfig is the configuration class handling all the RyzenAI quantization parameters.",K,F,Y;return x=new at({props:{title:"Quantization for Ryzen AI IPU",local:"quantization-for-ryzen-ai-ipu",headingTag:"h1"}}),Q=new at({props:{title:"Using Vitis AI Quantizer",local:"using-vitis-ai-quantizer",headingTag:"h2"}}),q=new at({props:{title:"RyzenAIOnnxQuantizer",local:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer",headingTag:"h3"}}),I=new k({props:{name:"class optimum.amd.ryzenai.RyzenAIOnnxQuantizer",anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer",parameters:[{name:"onnx_model_path",val:": Path"},{name:"config",val:": Optional = None"}],source:"https://github.com/huggingface/optimum.amd/blob/vr_149/optimum/amd/ryzenai/quantization.py#L63"}}),O=new k({props:{name:"from_pretrained",anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.from_pretrained",parameters:[{name:"model_or_path",val:": Union"},{name:"file_name",val:": Optional = None"}],parametersDescription:[{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.from_pretrained.model_or_path",description:`<strong>model_or_path</strong> (<code>Union[str, Path]</code>) &#x2014;
Can be either:<ul>
<li>A path to a saved exported ONNX Intermediate Representation (IR) model, e.g., \`./my_model_directory/.</li>
</ul>`,name:"model_or_path"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.from_pretrained.file_name(Optional[str],",description:`<strong>file_name(<code>Optional[str]</code>,</strong> defaults to <code>None</code>) &#x2014;
Overwrites the default model file name from <code>&quot;model.onnx&quot;</code> to <code>file_name</code>.
This allows you to load different model files from the same repository or directory.`,name:"file_name(Optional[str],"}],source:"https://github.com/huggingface/optimum.amd/blob/vr_149/optimum/amd/ryzenai/quantization.py#L89",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>An instance of <code>RyzenAIOnnxQuantizer</code>.</p>
`}}),T=new k({props:{name:"get_calibration_dataset",anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.get_calibration_dataset",parameters:[{name:"dataset_name",val:": str"},{name:"num_samples",val:": int = 100"},{name:"dataset_config_name",val:": Optional = None"},{name:"dataset_split",val:": Optional = None"},{name:"preprocess_function",val:": Optional = None"},{name:"preprocess_batch",val:": bool = True"},{name:"seed",val:": Optional = 2016"},{name:"token",val:": bool = None"},{name:"streaming",val:": bool = False"}],parametersDescription:[{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.get_calibration_dataset.dataset_name",description:`<strong>dataset_name</strong> (<code>str</code>) &#x2014;
The dataset repository name on the Hugging Face Hub or path to a local directory containing data files
to load to use for the calibration step.`,name:"dataset_name"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.get_calibration_dataset.num_samples",description:`<strong>num_samples</strong> (<code>int</code>, defaults to 100) &#x2014;
The maximum number of samples composing the calibration dataset.`,name:"num_samples"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.get_calibration_dataset.dataset_config_name",description:`<strong>dataset_config_name</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
The name of the dataset configuration.`,name:"dataset_config_name"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.get_calibration_dataset.dataset_split",description:`<strong>dataset_split</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
Which split of the dataset to use to perform the calibration step.`,name:"dataset_split"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.get_calibration_dataset.preprocess_function",description:`<strong>preprocess_function</strong> (<code>Optional[Callable]</code>, defaults to <code>None</code>) &#x2014;
Processing function to apply to each example after loading dataset.`,name:"preprocess_function"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.get_calibration_dataset.preprocess_batch",description:`<strong>preprocess_batch</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether the <code>preprocess_function</code> should be batched.`,name:"preprocess_batch"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.get_calibration_dataset.seed",description:`<strong>seed</strong> (<code>int</code>, defaults to 2016) &#x2014;
The random seed to use when shuffling the calibration dataset.`,name:"seed"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.get_calibration_dataset.token",description:`<strong>token</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the token generated when running <code>transformers-cli login</code> (necessary for some datasets
like ImageNet).`,name:"token"}],source:"https://github.com/huggingface/optimum.amd/blob/vr_149/optimum/amd/ryzenai/quantization.py#L192",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The calibration <code>datasets.Dataset</code> to use for the post-training static quantization calibration
step.</p>
`}}),w=new k({props:{name:"quantize",anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.quantize",parameters:[{name:"quantization_config",val:": QuantizationConfig"},{name:"dataset",val:": Dataset"},{name:"save_dir",val:": Union"},{name:"batch_size",val:": int = 1"},{name:"file_suffix",val:": Optional = 'quantized'"}],parametersDescription:[{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.quantize.quantization_config",description:`<strong>quantization_config</strong> (<code>QuantizationConfig</code>) &#x2014;
The configuration containing the parameters related to quantization.`,name:"quantization_config"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.quantize.save_dir",description:`<strong>save_dir</strong> (<code>Union[str, Path]</code>) &#x2014;
The directory where the quantized model should be saved.`,name:"save_dir"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.quantize.file_suffix",description:`<strong>file_suffix</strong> (<code>Optional[str]</code>, defaults to <code>&quot;quantized&quot;</code>) &#x2014;
The file_suffix used to save the quantized model.`,name:"file_suffix"},{anchor:"optimum.amd.ryzenai.RyzenAIOnnxQuantizer.quantize.calibration_tensors_range",description:`<strong>calibration_tensors_range</strong> (<code>Optional[Dict[str, Tuple[float, float]]]</code>, defaults to <code>None</code>) &#x2014;
The dictionary mapping the nodes name to their quantization ranges, used and required only when applying static quantization.`,name:"calibration_tensors_range"}],source:"https://github.com/huggingface/optimum.amd/blob/vr_149/optimum/amd/ryzenai/quantization.py#L133",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The path of the resulting quantized model.</p>
`}}),A=new at({props:{title:"QuantizationConfig",local:"optimum.amd.ryzenai.QuantizationConfig",headingTag:"h3"}}),R=new k({props:{name:"class optimum.amd.ryzenai.QuantizationConfig",anchor:"optimum.amd.ryzenai.QuantizationConfig",parameters:[{name:"format",val:": QuantFormat = <QuantFormat.QDQ: 1>"},{name:"calibration_method",val:": CalibrationMethod = <PowerOfTwoMethod.MinMSE: 1>"},{name:"activations_dtype",val:": QuantType = <QuantType.QUInt8: 1>"},{name:"activations_symmetric",val:": bool = True"},{name:"weights_dtype",val:": QuantType = <QuantType.QInt8: 0>"},{name:"weights_symmetric",val:": bool = True"},{name:"enable_dpu",val:": bool = True"}],parametersDescription:[{anchor:"optimum.amd.ryzenai.QuantizationConfig.is_static",description:`<strong>is_static</strong> (<code>bool</code>) &#x2014;
Whether to apply static quantization or dynamic quantization.`,name:"is_static"},{anchor:"optimum.amd.ryzenai.QuantizationConfig.format",description:`<strong>format</strong> (<code>QuantFormat</code>) &#x2014;
Targeted RyzenAI quantization representation format.
For the Operator Oriented (QOperator) format, all the quantized operators have their own ONNX definitions.
For the Tensor Oriented (QDQ) format, the model is quantized by inserting QuantizeLinear / DeQuantizeLinear
operators.`,name:"format"},{anchor:"optimum.amd.ryzenai.QuantizationConfig.calibration_method",description:`<strong>calibration_method</strong> (<code>CalibrationMethod</code>) &#x2014;
The method chosen to calculate the activations quantization parameters using the calibration dataset.`,name:"calibration_method"},{anchor:"optimum.amd.ryzenai.QuantizationConfig.activations_dtype",description:`<strong>activations_dtype</strong> (<code>QuantType</code>, defaults to <code>QuantType.QUInt8</code>) &#x2014;
The quantization data types to use for the activations.`,name:"activations_dtype"},{anchor:"optimum.amd.ryzenai.QuantizationConfig.activations_symmetric",description:`<strong>activations_symmetric</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to apply symmetric quantization on the activations.`,name:"activations_symmetric"},{anchor:"optimum.amd.ryzenai.QuantizationConfig.weights_dtype",description:`<strong>weights_dtype</strong> (<code>QuantType</code>, defaults to <code>QuantType.QInt8</code>) &#x2014;
The quantization data types to use for the weights.`,name:"weights_dtype"},{anchor:"optimum.amd.ryzenai.QuantizationConfig.weights_symmetric",description:`<strong>weights_symmetric</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to apply symmetric quantization on the weights.`,name:"weights_symmetric"},{anchor:"optimum.amd.ryzenai.QuantizationConfig.enable_dpu",description:`<strong>enable_dpu</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Determines whether to generate a quantized model that is suitable for the DPU. If set to True, the quantization
process will create a model that is optimized for DPU computations.`,name:"enable_dpu"}],source:"https://github.com/huggingface/optimum.amd/blob/vr_149/optimum/amd/ryzenai/configuration.py#L15"}}),{c(){l=s("meta"),V=a(),E=s("p"),W=a(),p(x.$$.fragment),S=a(),$=s("p"),$.innerHTML=pt,X=a(),p(Q.$$.fragment),j=a(),p(q.$$.fragment),B=a(),r=s("div"),p(I.$$.fragment),ot=a(),P=s("p"),P.textContent=gt,it=a(),y=s("div"),p(O.$$.fragment),rt=a(),N=s("p"),N.innerHTML=ft,st=a(),b=s("div"),p(T.$$.fragment),mt=a(),L=s("p"),L.innerHTML=ht,dt=a(),v=s("div"),p(w.$$.fragment),ct=a(),M=s("p"),M.innerHTML=zt,G=a(),p(A.$$.fragment),J=a(),u=s("div"),p(R.$$.fragment),lt=a(),H=s("p"),H.textContent=_t,K=a(),F=s("p"),this.h()},l(t){const n=Qt("svelte-u9bgzb",document.head);l=m(n,"META",{name:!0,content:!0}),n.forEach(e),V=o(t),E=m(t,"P",{}),C(E).forEach(e),W=o(t),g(x.$$.fragment,t),S=o(t),$=m(t,"P",{"data-svelte-h":!0}),U($)!=="svelte-qjwou4"&&($.innerHTML=pt),X=o(t),g(Q.$$.fragment,t),j=o(t),g(q.$$.fragment,t),B=o(t),r=m(t,"DIV",{class:!0});var c=C(r);g(I.$$.fragment,c),ot=o(c),P=m(c,"P",{"data-svelte-h":!0}),U(P)!=="svelte-1e8cy4a"&&(P.textContent=gt),it=o(c),y=m(c,"DIV",{class:!0});var Z=C(y);g(O.$$.fragment,Z),rt=o(Z),N=m(Z,"P",{"data-svelte-h":!0}),U(N)!=="svelte-19h4v7c"&&(N.innerHTML=ft),Z.forEach(e),st=o(c),b=m(c,"DIV",{class:!0});var tt=C(b);g(T.$$.fragment,tt),mt=o(tt),L=m(tt,"P",{"data-svelte-h":!0}),U(L)!=="svelte-1xfi4es"&&(L.innerHTML=ht),tt.forEach(e),dt=o(c),v=m(c,"DIV",{class:!0});var et=C(v);g(w.$$.fragment,et),ct=o(et),M=m(et,"P",{"data-svelte-h":!0}),U(M)!=="svelte-4dslow"&&(M.innerHTML=zt),et.forEach(e),c.forEach(e),G=o(t),g(A.$$.fragment,t),J=o(t),u=m(t,"DIV",{class:!0});var nt=C(u);g(R.$$.fragment,nt),lt=o(nt),H=m(nt,"P",{"data-svelte-h":!0}),U(H)!=="svelte-tmnpcg"&&(H.textContent=_t),nt.forEach(e),K=o(t),F=m(t,"P",{}),C(F).forEach(e),this.h()},h(){D(l,"name","hf:doc:metadata"),D(l,"content",It),D(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(r,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,n){i(document.head,l),d(t,V,n),d(t,E,n),d(t,W,n),f(x,t,n),d(t,S,n),d(t,$,n),d(t,X,n),f(Q,t,n),d(t,j,n),f(q,t,n),d(t,B,n),d(t,r,n),f(I,r,null),i(r,ot),i(r,P),i(r,it),i(r,y),f(O,y,null),i(y,rt),i(y,N),i(r,st),i(r,b),f(T,b,null),i(b,mt),i(b,L),i(r,dt),i(r,v),f(w,v,null),i(v,ct),i(v,M),d(t,G,n),f(A,t,n),d(t,J,n),d(t,u,n),f(R,u,null),i(u,lt),i(u,H),d(t,K,n),d(t,F,n),Y=!0},p:bt,i(t){Y||(h(x.$$.fragment,t),h(Q.$$.fragment,t),h(q.$$.fragment,t),h(I.$$.fragment,t),h(O.$$.fragment,t),h(T.$$.fragment,t),h(w.$$.fragment,t),h(A.$$.fragment,t),h(R.$$.fragment,t),Y=!0)},o(t){z(x.$$.fragment,t),z(Q.$$.fragment,t),z(q.$$.fragment,t),z(I.$$.fragment,t),z(O.$$.fragment,t),z(T.$$.fragment,t),z(w.$$.fragment,t),z(A.$$.fragment,t),z(R.$$.fragment,t),Y=!1},d(t){t&&(e(V),e(E),e(W),e(S),e($),e(X),e(j),e(B),e(r),e(G),e(J),e(u),e(K),e(F)),e(l),_(x,t),_(Q,t),_(q,t),_(I),_(O),_(T),_(w),_(A,t),_(R)}}}const It='{"title":"Quantization for Ryzen AI IPU","local":"quantization-for-ryzen-ai-ipu","sections":[{"title":"Using Vitis AI Quantizer","local":"using-vitis-ai-quantizer","sections":[{"title":"RyzenAIOnnxQuantizer","local":"optimum.amd.ryzenai.RyzenAIOnnxQuantizer","sections":[],"depth":3},{"title":"QuantizationConfig","local":"optimum.amd.ryzenai.QuantizationConfig","sections":[],"depth":3}],"depth":2}],"depth":1}';function Ot(ut){return vt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ct extends xt{constructor(l){super(),$t(this,l,Ot,qt,yt,{})}}export{Ct as component};
